head(PET_Dictation)

## model X ~ min(N(m, s) , exp(l))


data <- PET_Dictation$dictation

N<-length(data)
t_max<-max(PET_Dictation$dictation)

#sim <- rexp(N, l)
#plot(density(sim))
#rm(sim)

## function to optimize lambda

optL <- function(l.vec, m, s)
{
  error <- rep(NA, length(l.vec)) 
  for(i in c(1:length(l.vec)))
  {
    sim.df <- data.frame(x1 = rnorm(N,mean=m, sd=s), x2 = rexp(N, l.vec[i])) # muss ev gemittelt werden
    sim <- apply(sim.df, 1, min)
    # plot(density(sim))
    error[i] <- sum((sort(data) - sort(sim))^2)
  }
  return(l.vec[which.min(error)])
  print(l.vec)
}

## function to optimize mean
optM <- function(m.vec,l,s)
{
  error <- rep(NA,length(m.vec))
  for(i in c(1:length(m.vec)))
  {
    sim.df <- data.frame(x1=rnorm(N,m.vec[i]),sd=s, x2 = rexp(N, l))
    sim <- apply(sim.df,1,min)
    error[i] <- sum((sort(data)- sort(sim))^2)
  }
  return(m.vec[which.min(error)])
  print(m.vec)
}

## function to optimize standard deviation
optS <- function(m,l,s.vec)
{
  error <- rep(NA,length(s.vec))
  for(i in c(1:length(s.vec)))
  {
    sim.df <- data.frame(x1=rnorm(N,m,sd=s.vec[i]), x2= rexp(N,l))
    sim <- apply(sim.df,1,min)
    error [i] <- sum((sort(data)-sort(sim))^2)
  }
  return(s.vec[which.min(error)])
  print(s.vec)
}

## define vectore size
my.vec <- function(x,i){
  x.min <- x-(x/(i^2))
  x.max <- x+(x/(i^2))
  my.vec <-seq(from = x.min, to = x.max, length.out = 100)
  return(my.vec)
}

## m,s,l, i=laufvariable
m<-30
s<-10
l<-0.03

#set.seed
set.seed(50)

###iterations
for(i in c(1:1500)){
  
## optimize l  
my.l <- my.vec(l, i)
my.l <- my.l[my.l >0 & my.l < 1]
l <- optL(my.l,m, s)

## optimize m 
my.m <- my.vec(m, i)
my.m <- my.m[my.m >0 & my.m < 120]
m <- optM(my.m,l = l, s = s)

## optimize s
my.s <- my.vec(s, i)
my.s <- my.s[my.s >0 & my.s < 120]
s <- optS(my.s,l = l, m = m)

## plot iterations (e.g. 10th)
if(i %% 10 == 0){
  
  sim.df <- data.frame(x1=rnorm(N,m,sd=s), x2= rexp(N,l))
  sim <- apply(sim.df,1,min)
  norm <- sum(sim.df[, 1] == sim)
  error <- sum((sort(sim) - sort(data))^2)
  mypath<-file.path("D:/expo/PETCT/",paste("histogram_iteration_",i,".jpg",sep=""))
  jpeg(file=mypath)
  hist(sim, 
       main = paste("Iteration", i,"von N(my,s):", norm,", m =", sprintf("%.2f", m), ", s =", sprintf("%.2f", s), ", l =", sprintf("%.2f",l), "error = ", error), 
       xlim = c(0,t_max/3), ylim = c(0,t_max/3), 
       col = "blue",
       breaks=300,xlab="time(min)",ylab="frequency")
  par(new = TRUE)
  hist(data,
       main = "",
       xlim = c(0,t_max/3), ylim = c(0, t_max/3),
       breaks = 300,xlab="",ylab="")
  dev.off()
  }
}

write.table(
  paste("medium:",m,
      "n(total):",N,
      "n(norm):",norm,
      "standard deviation:",s,
      "lambda exponential:",l,
      "iteration:",i),"D:/expo/PETCT/results/information.txt",sep="\t")
library(truncnorm)
x <- rtruncnorm(n = 118, a = 0, b = Inf, mean = m, sd = s)
y<-summary(sim.df)
write.table(x,"D:/expo/PETCT/results/dictation_results.txt",sep="\t")
write.table(y,"D:/expo/PETCT/results/dictation_data_summary.txt",sep="\t")

require(car)
require(MASS)
qqp(x,"norm")

qqp(PET_CT_90_Dictation$dictation,"norm")






